//Clock namespace
var Clock = {};

//static vars
//settings
Clock.settings = new Settings();

//describes the different lines which make up a number
Clock.positions = [
	[
		{ 
			direction: "vertical",
			position: "left_top"
		},
		{ 
			direction: "horizontal",
			position: "top"
		},
		{ 
			direction: "vertical",
			position: "right_top"
		}							
	],
	[
		{
			direction: "horizontal",
			position: "middle"
		}
	],
	[
		{ 
			direction: "vertical",
			position: "left_bottom"
		},
		{ 
			direction: "horizontal",
			position: "bottom"
		},
		{ 
			direction: "vertical",
			position: "right_bottom"
		}				
	]
];

//maps the numbers to the positions
Clock.numbers = [
	//0
	[
		Clock.positions[0][0],
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[2][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	],
	
	//1
	[
		Clock.positions[0][2],
		Clock.positions[2][2]
	],
	
	//2
	[
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[1][0],
		Clock.positions[2][0],
		Clock.positions[2][1]
	],
	
	//3
	[
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[1][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	],
	
	//4
	[
		Clock.positions[0][0],
		Clock.positions[0][2],
		Clock.positions[1][0],
		Clock.positions[2][2]
	],
	
	//5
	[
		Clock.positions[0][0],
		Clock.positions[0][1],
		Clock.positions[1][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	],
	
	//6
	[
		Clock.positions[0][0],
		Clock.positions[0][1],
		Clock.positions[1][0],
		Clock.positions[2][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	],
	
	//7
	[
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[2][2]
	],
	
	//8
	[
		Clock.positions[0][0],
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[1][0],
		Clock.positions[2][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	],
	
	//9
	[
		Clock.positions[0][0],
		Clock.positions[0][1],
		Clock.positions[0][2],
		Clock.positions[1][0],
		Clock.positions[2][1],
		Clock.positions[2][2]
	]
];

Clock.days = [
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
];

Clock.months = [
	"Januari",
	"Februari",
	"March",
	"April",
	"May",
	"June",
	"Juli",
	"August",
	"Sebtember",
	"October",
	"November",
	"December"
];

Clock.previousTime = null;

Clock.setNumber = function(id, number){			
	var lines = Clock.numbers[number];
	var linesHtml = ""
	for(var i = 0; i < lines.length; i++){
		var line = lines[i];
		
		linesHtml += "<div class='line_" + line.direction + " line_" + line.direction + "_" + line.position + "'></div>";
	}

	$("#" + id).html(linesHtml);
};

Clock.setTime = function(){
	var now = new Date();
	if(Clock.previousTime.getMinutes() != now.getMinutes()){			
		Clock.setNumber("hours1", Math.floor(now.getHours() / 10));
		Clock.setNumber("hours2", now.getHours() % 10);
		Clock.setNumber("minutes1", Math.floor(now.getMinutes() / 10));
		Clock.setNumber("minutes2", now.getMinutes() % 10); 
		
		if(Clock.previousTime.getDate() != now.getDate()){
			$("#clock").attr("title", Clock.days[now.getDay()] + " " + now.getDate() + " " + Clock.months[now.getMonth()] + " " + now.getFullYear());
		}
		
		Clock.previousTime = now;
	}
};

Clock.updateColonAndTime = function(){
	if(Clock.settings.blink){
		$("#colon div").toggle();
	}
	Clock.setTime();
};

Clock.start = function(){
	Clock.previousTime = new Date();
	Clock.previousTime.setMinutes(Clock.previousTime.getMinutes()-1);
	Clock.previousTime.setDate(Clock.previousTime.getDate()-1);
	
	Clock.setTime();
	setInterval(Clock.updateColonAndTime, 500);
};

Clock.init = function(){
	System.Gadget.settingsUI = "settings.html";
	
	Clock.start();
};